function clusters = my_k_means(data,k, iter)



% data è Numero Punti x Numero Features

% punto uno istanzio le medie iniziali

[np,nf] = size(data);

medie = zeros(k,nf);

p_list = linspace(1,90,2*k);
p_list = p_list(2:2:end);


% istanziazione coi percentili
for i = 1:nf;
 medie(:,i) = prctile(data(:,i),p_list);
end

clusters = zeros(np,1);

%istanzio i clusters

for i = 1:np;
    d = zeros(k,1);
    for j=1:k;

        d(j) = sum((data(i,:)-medie(j,:)).^2);
    end
    [y,minimo] = min(d);
    clusters(i) = minimo;

end


for i=1:k
    medie(i,:) = mean(data(clusters==i,:),1);
end

% comincio l'algoritmo
clusters_old = zeros(np,1);

ind_iter = 0;
while sum(clusters_old==clusters)~= np && ind_iter <iter
    clusters_old  = clusters;
    
    for i = 1:np;

        d = zeros(k,1);
        for j=1:k;
            d(j) = sum((data(i,:)-medie(j,:)).^2);
        end
        [y,minimo] = min(d);
        clusters(i) = minimo;

    end

    % aggiorno i medoidi

    for i=1:k
        medie(i,:) = mean(data(clusters==i,:),1);
    end
    ind_iter = ind_iter + 1

end

if sum(clusters_old==clusters)~= np
    'NON CONVERGENZA'
else
    'CONVERGENZA'
end